﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="CS.aspx.cs" Inherits="CS" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <style type="text/css">
        body {
            font-family: Arial;
            font-size: 10pt;
        }

        table {
            border: 1px solid #ccc;
        }

            table th {
                background-color: #F7F7F7;
                color: #333;
                font-weight: bold;
            }

            table th, table td {
                padding: 5px;
                border-color: #ccc;
            }

        .Pager span {
            color: #333;
            background-color: #F7F7F7;
            font-weight: bold;
            text-align: center;
            display: inline-block;
            width: 20px;
            margin-right: 3px;
            line-height: 150%;
            border: 1px solid #ccc;
        }

        .Pager a {
            text-align: center;
            display: inline-block;
            width: 20px;
            border: 1px solid #ccc;
            color: #fff;
            color: #333;
            margin-right: 3px;
            line-height: 150%;
            text-decoration: none;
        }
    </style>
</head>
<body>
    <form id="form1" runat="server">
        <script type="text/javascript" src=" https://code.jquery.com/jquery-3.5.1.js"></script>
        <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.7/css/jquery.dataTables.min.css" />
        <script type="text/javascript" src="https://cdn.datatables.net/1.10.7/js/jquery.dataTables.min.js"></script>
        <link rel="stylesheet" href="https://code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css" />
        <script type="text/javascript" src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
        <script src="ASPSnippets_Pager.min.js" type="text/javascript"></script>
        <script type="text/javascript">
            $(function () {
                GetEmployees(parseInt(1));
                var checked = [];
                $('[id*=chkSelect]').on('click', function () {
                    if ($(this).is(":checked")) {
                        checked.push($(this).closest('tr').find('td').eq(1).html());
                    } else {
                        checked.pop($(this).closest('tr').find('td').eq(1).html());
                    }

                    $('[id*=hfCheckedIds]').val(checked.join(','));
                });
            });

            $(document).on("click", '.Pager .page', function () {
                GetEmployees(parseInt($(this).attr('page')));
            });

            var term = '';
            $(document).on("keyup", 'input[type=search]', function () {
                term = $(this).val();
                GetEmployees(parseInt(1));
            });

            $(document).on("change", '[id*=ddlPageSize]', function () {
                GetEmployees(parseInt(1));
            });

            $(document).on('click', '.view', function () {
                $('[id*=hfId]').val($(this).closest('tr').find('td').eq(1).html());
            });

            function SearchTerm() {
                return jQuery.trim($("input[type=search]").val());
            };

            var i = 0;
            function GetEmployees(pageIndex) {
                $.ajax({
                    type: "POST",
                    url: "CS.aspx/GetEmployees",
                    data: '{searchTerm: "' + SearchTerm() + '", pageIndex: ' + pageIndex + ', pageSize: ' + $("[id*=ddlPageSize]").val() + '}',
                    contentType: "application/json; charset=utf-8",
                    dataType: "json",
                    success: function (response) {
                        $('[id$=gvEmployees]').prepend($("<thead></thead>").append($('[id$=gvEmployees]').find("tr:first"))).DataTable().destroy();
                        var xmlDoc = $.parseXML(response.d);
                        var xml = $(xmlDoc);
                        var Employees = xml.find("Employees");
                        var row = $("[id$=gvEmployees] tbody tr:last-child").eq(0).clone(true);
                        $("[id$=gvEmployees] tbody tr").not($("[id$=gvEmployees] tbody tr:first-child")).remove();
                        $.each(Employees, function () {
                            $("td", row).eq(1).html($(this).find("EmployeeID").text());
                            $("td", row).eq(2).html($(this).find("FirstName").text());
                            $("td", row).eq(3).html($(this).find("LastName").text());
                            $("td", row).eq(4).html($(this).find("Address").text());
                            $("td", row).eq(5).html($(this).find("City").text());
                            $("td", row).eq(6).html($(this).find("Country").text());
                            $("[id$=gvEmployees]").append(row);
                            row = $("[id$=gvEmployees] tbody tr:last-child").eq(0).clone(true);
                        });
                        $("[id$=gvEmployees] tbody tr:first-child").remove();
                        if (i != 0) {
                            $('[id$=gvEmployees]').DataTable({
                                "paging": false,
                                "info": false
                            });
                        } else {
                            $('[id$=gvEmployees]')
                                .prepend($("<thead></thead>").append($('[id$=gvEmployees]').find("tr:first")))
                                .DataTable({
                                    "paging": false,
                                    "info": false
                                });
                        }
                        if (term != '') {
                            $('input[type=search]').val(term);
                        }
                        $('input[type=search]').focus();
                        i++;

                        var pager = xml.find("Pager");
                        $(".Pager").ASPSnippets_Pager({
                            ActiveCssClass: "current",
                            PagerCssClass: "pager",
                            PageIndex: parseInt(pager.find("PageIndex").text()),
                            PageSize: parseInt(pager.find("PageSize").text()),
                            RecordCount: parseInt(pager.find("RecordCount").text())
                        });
                    },
                    error: function (response) {
                        alert(response.responseText);
                    }
                });
            }
        </script>
        <asp:HiddenField ID="hfCheckedIds" runat="server" />
        <asp:HiddenField ID="hfId" runat="server" />
        Page Size: <asp:DropDownList runat="server" ID="ddlPageSize">
            <asp:ListItem Text="1" Value="1" />
            <asp:ListItem Text="5" Value="5" />
            <asp:ListItem Text="10" Value="10" />
        </asp:DropDownList>
        <asp:GridView ID="gvEmployees" runat="server" AutoGenerateColumns="False" DataKeyNames="EmployeeID" Width="100%">
            <Columns>
                <asp:TemplateField>
                    <ItemTemplate>
                        <asp:CheckBox ID="chkSelect" runat="server" />
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:BoundField DataField="EmployeeID" HeaderText="Id" />
                <asp:BoundField DataField="FirstName" HeaderText="First Name" />
                <asp:BoundField DataField="LastName" HeaderText="Last Name" />
                <asp:BoundField DataField="Address" HeaderText="Address" />
                <asp:BoundField DataField="City" HeaderText="City" />
                <asp:BoundField DataField="Country" HeaderText="Country" />
                <asp:TemplateField>
                    <ItemTemplate>
                        <asp:Button CssClass="view" Text="Unuseable" ID="Inkview" runat="server"
                            ForeColor="white" BackColor="#FF6600" />
                    </ItemTemplate>
                </asp:TemplateField>
            </Columns>
        </asp:GridView>
        <br />
        <div class="Pager" style="width: 100%"></div>
    </form>
</body>
</html>
