﻿Imports System.Configuration
Imports System.Data
Imports System.Data.SqlClient
Imports System.Web.Services

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            BindDummyRow()
        End If
    End Sub

    Private Sub BindDummyRow()
        Dim dummy As DataTable = New DataTable()
        dummy.Columns.Add("EmployeeID")
        dummy.Columns.Add("FirstName")
        dummy.Columns.Add("LastName")
        dummy.Columns.Add("Address")
        dummy.Columns.Add("City")
        dummy.Columns.Add("Country")
        dummy.Rows.Add()
        gvEmployees.DataSource = dummy
        gvEmployees.DataBind()
    End Sub

    <WebMethod>
    Public Shared Function GetEmployees(ByVal pageIndex As Integer, ByVal searchTerm As String, ByVal pageSize As Integer) As String
        Dim query As String = "[Employees_GetEmployeesPageWise]"
        Dim cmd As SqlCommand = New SqlCommand(query)
        cmd.CommandType = CommandType.StoredProcedure
        cmd.Parameters.AddWithValue("@SearchTerm", searchTerm)
        cmd.Parameters.AddWithValue("@PageIndex", pageIndex)
        cmd.Parameters.AddWithValue("@PageSize", pageSize)
        cmd.Parameters.Add("@RecordCount", SqlDbType.Int, 4).Direction = ParameterDirection.Output
        Return GetData(cmd, pageIndex, pageSize).GetXml()
    End Function

    Private Shared Function GetData(ByVal cmd As SqlCommand, ByVal pageIndex As Integer, ByVal pageSize As Integer) As DataSet
        Dim strConnString As String = ConfigurationManager.ConnectionStrings("conString").ConnectionString
        Using con As SqlConnection = New SqlConnection(strConnString)
            Using sda As SqlDataAdapter = New SqlDataAdapter()
                cmd.Connection = con
                sda.SelectCommand = cmd
                Using ds As DataSet = New DataSet()
                    sda.Fill(ds, "Employees")
                    Dim dt As DataTable = New DataTable("Pager")
                    dt.Columns.Add("PageIndex")
                    dt.Columns.Add("PageSize")
                    dt.Columns.Add("RecordCount")
                    dt.Rows.Add()
                    dt.Rows(0)("PageIndex") = pageIndex
                    dt.Rows(0)("PageSize") = pageSize
                    dt.Rows(0)("RecordCount") = cmd.Parameters("@RecordCount").Value
                    ds.Tables.Add(dt)
                    Return ds
                End Using
            End Using
        End Using
    End Function
End Class
